const request = require('request-promise');
const { readFile, writeFile } = require('fs').promises;
const fnbr = require('fnbr')
const { Client, Party } = require('fnbr');
function sleep(timeout) {
  return new Promise((res) => setTimeout(() => res(), timeout));
}

let client;


//Changing the skin
async function cskin(Authorization, name, m) {
  let res = await request('https://fortniteapi.io/items/list?name=' + encodeURI(name), {
    headers: { Authorization },
    json: true
  })
  if (res.itemsCount < 1) {
  console.log(`No skin with the name ${name} exists. Maybe check to see if you spelt it wrong?`)
  (`No skin with the name ${name} exists. Maybe check to see if you spelt it wrong?`)
  }else {
    await client.party.me.setOutfit(res.items[0][0].id)
    console.log(`Skin changed to ${name}`)
    m.reply(`Skin changed to ${name}`)
  }
  }

//Changing the Backpack
async function cbackpack(Authorization, name, m) {
      let res = await request('https://fortniteapi.io/items/list?name=' + encodeURI(name), {
        headers: { Authorization },
        json: true
      })
      if (res.itemsCount < 1){
      console.log(`No backpack with the name ${name} exists. Maybe check to see if you spelt it wrong?`)
      m.reply(`No backpack with the name ${name} exists. Maybe check to see if you spelt it wrong?`)
    }else{
        await client.party.me.setBackpack(res.items[0][0].id)
        console.log(`Backpack changed to ${name}`)
        m.reply(`Backpack changed to ${name}`)
      }
    }

//Changing the pickaxe
async function cpickaxe(Authorization, name, m) {
      let res = await request('https://fortniteapi.io/items/list?name=' + encodeURI(name), {
        headers: { Authorization },
        json: true
      })
      if (res.itemsCount < 1){
        m.reply(`No Pickaxe with the name ${name} exists. Maybe check to see if you spelt it wrong?`)
        console.log(`No Pickaxe with the name ${name} exists. Maybe check to see if you spelt it wrong?`)
      }else{
        await client.party.me.setPickaxe(res.items[0][0].id)
        m.reply(`Pickaxe changed to ${name}`)
        console.log(`Pickaxe has been changed to ${name}`)
      }
    }

//Changing the emote
async function cemote(Authorization, name, m) {
      let res = await request('https://fortniteapi.io/items/list?name=' + encodeURI(name), {
        headers: { Authorization },
        json: true
      })
      if (res.itemsCount < 1){
        m.reply(`No Emote with the name ${name} exists. Maybe check to see if you spelt it wrong?`)
        console.log(`No Emote with the name ${name} exists. Maybe check to see if you spelt it wrong?`)
      }else{
        await client.party.me.setEmote(res.items[0][0].id)
        m.reply(`Emote changed to ${name}`)
        console.log(`Emote has been changed to ${name}`)
      }
    }

//Equips all new skins in the files
async function newsk(Authorization, m){
  let res = await request('https://fortniteapi.io/items/upcoming?lang=en', {
    headers: { Authorization },
        json: true
  })
  if (res.itemsCount < 1) {
    m.reply(`Nothing new was found... weird...`)
    console.log(`No new items were found, maybe an api error?`)
  } else {
      res.items.forEach(async v =>  {
      if(v.id.startsWith("CID")){
        client.party.me.setOutfit(v.id)
        sleep(10000)
      }
    });
    m.reply(`Now equipping all skins in the files that are unreleased/ new (Some of these may already be out, that is just an issue with the game files. Sorry!).`)
    console.log("Equipped all new skins in the files.")
  }
}


//Gathers info on a cosmetic item
async function info(Authorization, name, m) {
  let res = await request('https://fortniteapi.io/items/list?name=' + encodeURI(name), {
    headers: { Authorization },
        json: true
  })
  if (res.itemsCount < 1) {
    m.reply(`No item with the name ${name} exists. Maybe check to see if you spelt it wrong?`)
    console.log(`Item ${name} doesn't exist!`)
  } else {
    let res2 = await request('https://fortniteapi.io/items/get?id=' + encodeURI(res.items[0][0].id), {
      headers: { Authorization },
      json: true
    })
    let item = res2.item
    console.log(`Info gathered on Item ${item.name}`)
    m.reply(`
    Item Name: ${item.name}
    Item Id: ${item.id}
    Item Description: ${item.description}
    Item Type: ${item.type}
    Item Rarity: ${item.rarity}
    Item Price: ${item.price}
    Item Image: ${item.full_background}
    Release Date: ${item.releaseDate}
    Last seen: ${item.lastAppearance}
    Set: ${item.set}
    Tags: ${item.gameplayTags}
    `)
  }
}

//Lists all of the items currently in the shop
async function shop(Authorization, m) {
  let res = await request('https://fortniteapi.io/v1/shop?lang=en', {
    headers: { Authorization },
    json: true
  })
  if (res.itemsCount < 1) {
    m.reply(`There was an error...`)
    console.log(`No new items were found, maybe an api error?`)
  } else {
    async function shpitems() {
      try{
      res.featured.forEach(item => {
        m.reply(`
        Item Name: ${item.name}
        Item Description: ${item.description}
        Item Type: ${item.type}
        Item Rarity: ${item.rarity}
        Item Price: ${item.price}
        Item Image: ${item.full_background}
        `)
      });
      res.daily.forEach(item => {
        m.reply(`
        Item Name: ${item.name}
        Item Description: ${item.description}
        Item Type: ${item.type}
        Item Rarity: ${item.rarity}
        Item Price: ${item.price}
        Item Image: ${item.full_background}
        `)
      });
      res.specialFeatured.forEach(item => {
        m.reply(`
        Item Name: ${item.name}
        Item Description: ${item.description}
        Item Type: ${item.type}
        Item Rarity: ${item.rarity}
        Item Price: ${item.price}
        Item Image: ${item.full_background}
        `)
      });
      res.specialDaily.forEach(item => {
        m.reply(`
        Item Name: ${item.name}
        Item Description: ${item.description}
        Item Type: ${item.type}
        Item Rarity: ${item.rarity}
        Item Price: ${item.price}
        Item Image: ${item.full_background}
        `)
      });
      res.community.forEach(item => {
        m.reply(`
        Item Name: ${item.name}
        Item Description: ${item.description}
        Item Type: ${item.type}
        Item Rarity: ${item.rarity}
        Item Price: ${item.price}
        Item Image: ${item.full_background}
        `)
      });
      res.offers.forEach(item => {
        m.reply(`
        Item Name: ${item.name}
        Item Description: ${item.description}
        Item Type: ${item.type}
        Item Rarity: ${item.rarity}
        Item Price: ${item.price}
        Item Image: ${item.full_background}
        `)
      });
    }catch(e){
      return;
    }
    }
    await shpitems()
    console.log("Listed all items currently in the shop!")
  }
}

//Adding a friend
async function adds(name, m) {
      client.addFriend(name)
      m.reply(`Sent Friend Request to ${name}!`)
      console.log(`Sent Friend Request to ${name}`)
  }
//Joining the lobby
async function join(m) {
  try{
    await client.friends.find((f) => f.displayName == m.author.displayName).joinParty()
    m.reply(`Joined ${m.author.displayName}'s Party`)
    console.log(`Joined ${m.author.displayName}'s Party`)
    await client.party.me.setEmote("eid_wave")
    sleep(2000)

  }catch(e){
    m.reply(`Hm, looks like i couldnt join that party. Check if the party is on private, if it is i cant join.`)
    console.log(`Couldnt join ${m.author.displayName}'s party. Error: ${e}`)
  }
}

//Leaving the lobby
async function cleave(m) {
  await client.party.me.setEmote("eid_wave")
  sleep(2000)
  await client.party.leave()
      m.reply(`Goodbye!`)
      console.log(`I left the party as requested`)
}

//Login
async function clogin(a, p) {
    let auth;
    try {
      auth = {
        deviceAuth: JSON.parse(await readFile('./deviceAuth.json'))
      };
    } catch (e) {
      console.log("(Get a new auth code here: https://www.epicgames.com/id/logout?redirectUrl=https%3A//www.epicgames.com/id/login%3FredirectUrl%3Dhttps%253A%252F%252Fwww.epicgames.com%252Fid%252Fapi%252Fredirect%253FclientId%253D3446cd72694c4a4485d81b77adbb2141%2526responseType%253Dcode)")
      auth = {
        authorizationCode: async () => Client.consoleQuestion('Please enter an authorization code: ')
      };
    }
    client = new Client({
      auth,
    });

    client.on('deviceauth:created', (da) => writeFile('./deviceAuth.json', JSON.stringify(da, null, 2)));
    await client.login();
    console.log(`Logged in as ${client.user.displayName}`)
      client.party.me.setOutfit("cid_337_athena_commando_f_celestial")
      client.party.me.setBackpack("bid_562_celestialfemale")
      client.party.me.setPickaxe("pickaxe_id_116_celestial")
      client.party.me.setEmote("eid_wave")
      client.party.me.setLevel("999999999")
      client.party.me.setBattlepass("true", "999999999", "100", "100")
      client.setStatus("This bot was made using ZitRi's Lobby Bot Npm! (Credits ZitRi#0001) Happy Botting!")

      if(p === "pr"){
        console.log("private")
      }else{
        if(p === "pu"){
        console.log("public")
        }else{
          if(!p){
            console.log("No privacy setting specified, the bot is now private by default")
          }
        }
      }

        client.on('friend:request', async (frq) => {
          if(!p){
            p = "pr"
          }
          if(p === "pr"){
          await frq.decline()
          .then(friend => {
            console.log(`Friend Request from ${friend.displayName} Declined.`)
          });
          }else{
          if(p === "pu"){
          await frq.accept()
          .then(friend => {
            console.log(`Friend Request from ${friend.displayName} Accepted.`)
          });
          }
        }
        })
      client.on('party:invite', async (inv) => {
          await inv.accept()
          console.log(`Invite from ${inv.sender.displayName} Accepted`)
          sleep(2000)
          await client.party.me.setEmote("eid_wave")
      })

      client.on('friend:message', async (msg) => {
        let m = msg
        if (!m.content.startsWith('!')) return;
        const args = m.content.substr(1).split(" ");
        const name = args.slice(1).join(" ")
        const command = args[0]

        console.log(m.author.displayName + ":" + m.content)

        if(command === "skin"){
          cskin(a, name, m)
        }else{
          if(command === "backpack"){
            cbackpack(a, name, m)
          }else{
            if(command === "pickaxe"){
              cpickaxe(a, name, m)
            }else{
              if(command === "emote"){
                cemote(a, name, m)
              }else{
                if(command === "add"){
                  adds(name, m)
                }else{
                  if(command === "leave"){
                    cleave(m)
                  }else{
                    if(command === "join"){
                      join(m)
                    }else{
                      if(command === "new"){
                        newsk(a, m, )
                      }else{
                        if(command === "info"){
                         info(a, name, m)
                        }else{
                          if(command === "shop"){
                            shop(a, m)
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      })
  }

      exports.login = clogin